import { Message } from "discord.js";
import { CommandSet, Command } from "src/model/command";
import got from "got";
import { logger } from "src/logging";

@CommandSet
export class Inspire {

    async doInspire(msg: Message): Promise<void> {
        const result = await got.get("https://inspirobot.me/api?generate=true");
        if(result.statusCode != 200) {
            logger.error("Failed to get inspiration, status code: %s", result.statusCode);
            await msg.channel.send(`${msg.author.toString()} Sorry, couldn't get inspiration :(.`);
            return;
        }
        msg.channel.send(`${msg.author.toString()} Here is a piece of my wisdom:`, {
            files: [ result.body ]
        });
    }

    @Command({ pattern: "inspire me", documentation: {description: "Generates an inspiring quote just for you", example: "inspire me"}})
    inspire(msg: Message): void {
        this.doInspire(msg);
    }
}